config/routes.rb
Rails.application.routes.draw do
  resources :users
  resources :books
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  get 'hola', to: 'welcome#hello'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/book.rb
class Book < ApplicationRecord
end

app/models/pet.rb
class Pet < ApplicationRecord
end

app/models/user.rb
class User < ApplicationRecord
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
    before_action :set_locale
    def set_locale
        I18n.locale = 'es'
    end
end

app/controllers/books_controller.rb
class BooksController < ApplicationController
  before_action :set_book, only: %i[ show edit update destroy ]

  # GET /books or /books.json
  def index
    byebug
    #binding.pry
    @books = Book.all
  end

  # GET /books/1 or /books/1.json
  def show
  end

  # GET /books/new
  def new
    @book = Book.new
  end

  # GET /books/1/edit
  def edit
  end

  # POST /books or /books.json
  def create
    @book = Book.new(book_params)

    respond_to do |format|
      if @book.save
        format.html { redirect_to @book, notice: "Book was successfully created." }
        format.json { render :show, status: :created, location: @book }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @book.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /books/1 or /books/1.json
  def update
    respond_to do |format|
      if @book.update(book_params)
        format.html { redirect_to @book, notice: "Book was successfully updated." }
        format.json { render :show, status: :ok, location: @book }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @book.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /books/1 or /books/1.json
  def destroy
    @book.destroy
    respond_to do |format|
      format.html { redirect_to books_url, notice: "Book was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_book
      @book = Book.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def book_params
      params.require(:book).permit(:title, :author, :description, :isbn, :page_count)
    end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :set_user, only: %i[ show edit update destroy ]

  # GET /users or /users.json
  def index
    @users = User.all
  end

  # GET /users/1 or /users/1.json
  def show
  end

  # GET /users/new
  def new
    @user = User.new
  end

  # GET /users/1/edit
  def edit
  end

  # POST /users or /users.json
  def create
    @user = User.new(user_params)

    respond_to do |format|
      if @user.save
        format.html { redirect_to @user, notice: "User was successfully created." }
        format.json { render :show, status: :created, location: @user }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /users/1 or /users/1.json
  def update
    respond_to do |format|
      if @user.update(user_params)
        format.html { redirect_to @user, notice: "User was successfully updated." }
        format.json { render :show, status: :ok, location: @user }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /users/1 or /users/1.json
  def destroy
    @user.destroy
    respond_to do |format|
      format.html { redirect_to users_url, notice: "User was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_user
      @user = User.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def user_params
      params.require(:user).permit(:first_name, :last_name, :address, :about_me, :phone)
    end
end

app/controllers/welcome_controller.rb
class WelcomeController < ApplicationController
    def hello
        #@credentials = Rails.application.credentials.hello
        pet = Pet.first
        @variable = "Me llamo #{pet.name} y soy de raza #{pet.breed}"
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/books_helper.rb
module BooksHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/books/_form.html.erb
<%= form_with(model: book) do |form| %>
  <% if book.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(book.errors.count, "error") %> prohibited this book from being saved:</h2>

      <ul>
        <% book.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :title, t('.title') %>
    <%= form.text_field :title %>
  </div>

  <div class="field">
    <%= form.label :author, t('.author') %>
    <%= form.text_field :author %>
  </div>

  <div class="field">
    <%= form.label :description, t('.description') %>
    <%= form.text_area :description %>
  </div>

  <div class="field">
    <%= form.label :isbn, t('.isbn') %>
    <%= form.text_field :isbn %>
  </div>

  <div class="field">
    <%= form.label :page_count, t('.page_count') %>
    <%= form.number_field :page_count %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/books/edit.html.erb
<h1>Editing Book</h1>

<%= render 'form', book: @book %>

<%= link_to 'Show', @book %> |
<%= link_to 'Back', books_path %>

app/views/books/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Books</h1>

<table>
  <thead>
    <tr>
      <th>Title</th>
      <th>Author</th>
      <th>Description</th>
      <th>Isbn</th>
      <th>Page count</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @books.each do |book| %>
      <tr>
        <td><%= book.title %></td>
        <td><%= book.author %></td>
        <td><%= book.description %></td>
        <td><%= book.isbn %></td>
        <td><%= book.page_count %></td>
        <td><%= link_to 'Show', book %></td>
        <td><%= link_to 'Edit', edit_book_path(book) %></td>
        <td><%= link_to 'Destroy', book, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Book', new_book_path %>

app/views/books/new.html.erb
<h1>New Book</h1>

<%= render 'form', book: @book %>

<%= link_to 'Back', books_path %>

app/views/books/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Title:</strong>
  <%= @book.title %>
</p>

<p>
  <strong>Author:</strong>
  <%= @book.author %>
</p>

<p>
  <strong>Description:</strong>
  <%= @book.description %>
</p>

<p>
  <strong>Isbn:</strong>
  <%= @book.isbn %>
</p>

<p>
  <strong>Page count:</strong>
  <%= @book.page_count %>
</p>

<%= link_to 'Edit', edit_book_path(@book) %> |
<%= link_to 'Back', books_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>MiApp</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/users/_form.html.haml
-# frozen_string_literal: true
= simple_form_for(@user) do |f|
  = f.error_notification
  = f.error_notification message: f.object.errors[:base].to_sentence if f.object.errors[:base].present?

  .form-inputs
    = f.input :first_name, label: t('.first_name')
    = f.input :last_name, label: t('.last_name')
    = f.input :address, label: t('.address')
    = f.input :about_me, label: t('.about')
    = f.input :phone, label: t('.phone')

  .form-actions
    = f.button :submit

app/views/users/edit.html.haml
%h1 Editing user

= render 'form'

= link_to 'Show', @user
\|
= link_to 'Back', users_path

app/views/users/index.html.haml
%h1 Listing users

%table
  %thead
    %tr
      %th First name
      %th Last name
      %th Address
      %th About me
      %th Phone
      %th
      %th
      %th

  %tbody
    - @users.each do |user|
      %tr
        %td= user.first_name
        %td= user.last_name
        %td= user.address
        %td= user.about_me
        %td= user.phone
        %td= link_to 'Show', user
        %td= link_to 'Edit', edit_user_path(user)
        %td= link_to 'Destroy', user, :method => :delete, :data => { :confirm => 'Are you sure?' }

%br

= link_to 'New User', new_user_path

app/views/users/new.html.haml
%h1 New user

= render 'form'

= link_to 'Back', users_path

app/views/users/show.html.haml
%p#notice= notice

%p
  %b First name:
  = @user.first_name
%p
  %b Last name:
  = @user.last_name
%p
  %b Address:
  = @user.address
%p
  %b About me:
  = @user.about_me
%p
  %b Phone:
  = @user.phone

= link_to 'Edit', edit_user_path(@user)
\|
= link_to 'Back', users_path

app/views/welcome/hello.html.haml
Hello!!!
= @variable